    Program HOLO

!  HAM6 layout.
!
!  Coordinates are referenced to HAM6,  as reported by Eduardo
!

    use optocad
    use rsplot
!
    character(len=128)        :: ocd(100)=''
    character(len=128)       :: mir(3)=''
    character(len=128)       :: tt(8)=''
!
    ocd(1)='b -2815.,  304.8,  2.1, 3.27, 0.                       # Input beam'
!                       act         X       Y      Angle               act     curv      refl
    ocd(2) ='i hamisi_table.ocd, 0.0,0.0,0.0 # Table'
!
!   Mode matching telescope dL = (3.646m, 1.395m, 0.708m, 0.268m)  
!        
    ocd(3)='i  tt, 625.0, 502.0,  5.52   # TipTilt_1 >>>@cc40,100' 
    ocd(99)='i fast_shutter.ocd, 250.0, 450.0, 180.0 % # FastShut >>>@cc0,100'
    ocd(4)='i  tt,-757.0, 313.0, -176.63 # TipTilt_2 >>>@cc0,-100'
    ocd(5)='i  tt,-120.9, 301.0,  29.0   # TipTilt_3 >>>@cc60,-90'
    ocd(95)='i beam_dump.ocd, -900., 280.0, 185.0   %     # Dump_2 >>@cc0,60'
 !
!   AS-ASC_QPD  beampath
!
    ocd(6)='i mirror, 725.0, 508.0, 46.6   % a=r   # M4 >>@cc35,25'
    ocd(7)='i mirror, 725.0, 364.0, -45.0  % a=r # M5 >>@cc25,-25'
    ocd(8)='i mirror, 500.0, 364.0, -136.0 % a=str   # M6 >>@cc-25,-25'
    ocd(9)='i pico_mirror.ocd, 350.0, 364.0, -135.0 % a=r    # M7 >>@cc-30,-25'
    ocd(30)='i mirror, 350.0,540.0,   90.0 % a=t, cc=0.013    # L1 >>@cc45,0'
    ocd(10)='i dcpd.ocd, 350.0, 589.0, 90.0 % d    # AS-C >>@cc0,35'        
    ocd(11)='i OMC_bowtie.ocd, -356.5, -12.6,-31.0 # OMC >>@'
    ocd(98)='i beam_diverter.ocd, 535.0, 650.0, -90.0 % # BDiv_1 >>@cc30,70'
!!
!!   REFL beam path
!!    
    ocd(12)='i mirror, -189.4, 255.0,   16.0   % a=r  # M8 >>@cc-40,-10' 
    ocd(13)='i pico_mirror.ocd, -650.0, 580.0,  163.4,  % a=r # M9 >>@cc-50,10'
    ocd(14)='i pico_mirror.ocd,  150.0, 607.0,  -39.1,  % a=r   # M10 >>@cc-60,-25'
    ocd(15)='i mirror,  133.7, 700.0,  50.0,  % a=srt   # M11 >>@cc55,25'
    ocd(16)='i omc_refl_qpd_sled.ocd, 75.0, 725.4, 180.0 # REFL_QPD >>@'
    ocd(97)='i beam_diverter.ocd, 125.0, 950.0, 90.0 % # BDiv_2 >>@cc50,60'
!!
!!   AS beam path
!!
    ocd(17)='i as_qpd_sled.ocd, 400., 150.0,  0.0 # AS_QPD >>@'
    ocd(18)='i pico_mirror.ocd,  300.0, 295.0, 44.6, % a=r # M12 >>@cc-45,-45'
    ocd(19)='i pico_mirror.ocd,  300.0, 124.6, -135.0 % a=r # M13 >>@cc-10,-40'
!
!   OMC trans path
!
    ocd(20)='i mirror,  -550, 121., -147.,   % a=r # M14 >>@cc-50,-25'
!    ocd(21)='i mirror,  -450, 100, -133.0,  % a=r # M15 >>@cc-25,-25' 
    ocd(96)='i beam_dump.ocd, 350, -360.0, -45.0   %     # Dump_1 >>@cc0,-70'
    ocd(94)='i ham_viewports.ocd, 0.0,    0.0,  0.0 %'
    ocd(93)='i septumports.ocd, 0.0, 0.0, 0.0 %'   

!!
!   A 2" mirror
!
    mir(1)='p a=str, cc=0., rr=1.0'
    mir(2)='d @a,  0.,  0.,  rd=25.4,  ag=0., c=cc, r=rr #Mirror@lc9,-7'
    mir(3)=' +  t,  dx=9.5, da=180.0'

    tt(1) ='p a=str, cc=0.'
    tt(2) ='d  str, 0.0, 0.0, rd=25.4 # TipTilt'
    tt(3) ='+  t, dm=9.0, da=180'
    tt(4) ='d  h, -26., 0.,  rd= 62, icc=13 '
    tt(5) ='+  h, dm=90.0, da=180'
    tt(6) ='h  h, -26., 0., rd=25.4'
    tt(7) ='+  h, dm=90.0, rd=25.4'  
    !
    call oc_init(unit='mm', &         ! Initialize OPTOCAD 
                 pform = 'LETTER_L')  !Landscape letter size
     call oc_frame(-1500.,-1500.,1500.0,1500., &  !frame at xbeg, ybeg, xend, yend
         xbl=25., &                                                  ! bottom left in paper units
         ybl=25., &                                                  ! bottom left in paper units
         scale=0.06, &                                           ! scale
         glp=0)                                                        ! line style
    
    call oc_set(nice = 1,        &     ! One iteration for cavity eigenray
                pstat= 0,        &     ! Switch off output of statistics
                      fslb = 2.,       &     ! Font size for labels (mm)
                      rix = (/1.44963/), & ! index of refraction
                      mct=2,    & ! Cavity treatment (2=resonance, 3=resonance+eigenmode)
                      pctl=0,      & ! show cavity test cycle
                print='rs s1 s2 act x1 y1 x2 y2 rd  w1t w2t lb', &
                write='rs x1 y1 x2 y2  Gp1 Gp2 lb')
    call oc_bind('mirror',mir)
    call oc_bind('tt',tt)
    call oc_input(ocd)                 ! read in data of optical components
!
    call oc_trace(of='ham6_center_bowtie.txt')                      ! Trace all ray segments
    call oc_beam(3.0,fill=ps_color((/1.,.8,.8/)))! Plot outer part of beam
    call oc_beam(2.0,fill=ps_color((/1.,.6,.6/)))! Plot middle part of beam
    call oc_beam(1.0,fill=2)                     ! Plot inner part of beam
    call oc_beam(0.0,1,5,.2)     ! Plot the beam axes in black 
                                 ! (add rnc=1 to plot numbers)
    call oc_surf(lw=.3)          ! Plot all surfaces with linewidth 0.3mm
!
    call oc_exit
    end                    
